/*
 * Copyright 2022 Fluence Labs Limited
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

use air_test_utils::prelude::*;

//const PREV_DATA: &str = r#"{"trace":[{"call":{"executed":{"scalar":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"}}},{"call":{"executed":{"scalar":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc"}}},{"call":{"executed":{"scalar":"some_value"}}},{"call":{"executed":{"scalar":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v"}}},{"call":{"executed":{"scalar":["id"]}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":1665506843}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","tetraplet":{"function_name":"-relay-","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":"getDataSrv"},"trace_pos":5}]}}},{"call":{"executed":{"scalar":[109,198,222,202,133,116,16,233,252,153,13,6,152,166,81,237,88,107,215,47,37,96,5,113,43,90,102,248,164,151,16,35]}}},{"call":{"executed":{"scalar":{"error":[],"signature":[[157,10,75,157,224,190,235,95,105,91,236,31,212,174,224,97,226,246,65,6,75,212,4,89,126,92,93,100,61,16,197,45,131,20,125,170,170,138,87,102,93,50,207,220,143,93,237,162,240,221,180,100,253,105,79,231,135,55,141,69,23,160,69,4]],"success":true}}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","tetraplet":{"function_name":"-relay-","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":"getDataSrv"},"trace_pos":5}]}}},{"call":{"executed":{"stream":{"value":{"issued_by":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","issuer_signature":[157,10,75,157,224,190,235,95,105,91,236,31,212,174,224,97,226,246,65,6,75,212,4,89,126,92,93,100,61,16,197,45,131,20,125,170,170,138,87,102,93,50,207,220,143,93,237,162,240,221,180,100,253,105,79,231,135,55,141,69,23,160,69,4],"key_id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","relay_id":["12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"],"service_id":["id"],"solution":[],"timestamp_issued":1665506843,"value":"some_value"},"generation":0}}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":{"issued_by":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","issuer_signature":[157,10,75,157,224,190,235,95,105,91,236,31,212,174,224,97,226,246,65,6,75,212,4,89,126,92,93,100,61,16,197,45,131,20,125,170,170,138,87,102,93,50,207,220,143,93,237,162,240,221,180,100,253,105,79,231,135,55,141,69,23,160,69,4],"key_id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","relay_id":["12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"],"service_id":["id"],"solution":[],"timestamp_issued":1665506843,"value":"some_value"},"tetraplet":{"function_name":"create_record_metadata","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":"registry"},"trace_pos":11}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[]}}},{"call":{"executed":{"scalar":1665506844}}},{"call":{"executed":{"scalar":[227,176,196,66,152,252,28,20,154,251,244,200,153,111,185,36,39,174,65,228,100,155,147,76,164,149,153,27,120,82,184,85]}}},{"call":{"executed":{"stream":{"value":{"error":[],"signature":[[231,8,196,58,49,131,29,64,40,242,102,12,151,190,220,169,65,66,93,195,106,200,42,25,178,112,183,67,74,242,113,74,73,112,108,55,0,70,98,2,254,151,132,238,127,180,64,104,254,223,35,170,47,236,174,68,172,201,245,103,109,169,53,14]],"success":true},"generation":0}}}}],"streams":{},"version":"0.2.2","lcid":7,"r_streams":{"$successful":{"476":[0]},"$signature":{"2927":[1]},"$result":{"957":[1]},"$relay_id":{"570":[1]},"$error_get":{"502":[0]},"$error-0":{"899":[0]},"$success":{"528":[0]}}}"#;
const PREV_DATA: &str = r#"{"trace":[{"call":{"executed":{"scalar":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}}},{"ap":{"gens":[0]}},{"ap":{"gens":[0]}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[{"result":"will upload","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":1},{"result":"/Users/folex/Development/fluencelabs/subrosy/src/scheduled/scheduled.simple.air","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":2},{"result":"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":3}]}}},{"call":{"executed":{"scalar":{}}}},{"call":{"executed":{"scalar":""}}},{"call":{"executed":{"scalar":{"error":"","multiaddr":"/ip4/134.209.186.43/tcp/5001/p2p/12D3KooWEhCqQ9NBnmtSfNeXSNfhgccmH86xodkCUxZNEXab6pkw","success":true}}}},{"call":{"executed":{"scalar":""}}},{"ap":{"gens":[0]}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[{"result":"success","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":9},{"result":"/ip4/134.209.186.43/tcp/5001/p2p/12D3KooWEhCqQ9NBnmtSfNeXSNfhgccmH86xodkCUxZNEXab6pkw","tetraplet":{"function_name":"get_external_api_multiaddr","json_path":".$.multiaddr","peer_pk":"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv","service_id":"aqua-ipfs"},"trace_pos":10}]}}},{"call":{"executed":{"scalar":{}}}},{"call":{"executed":{"scalar":"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h"}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[{"result":"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h","tetraplet":{"function_name":"upload","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":"ipfs_client"},"trace_pos":14}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[]}}},{"call":{"executed":{"scalar":{}}}},{"call":{"executed":{"scalar":1665582319}}},{"call":{"executed":{"scalar":[124,177,64,18,168,199,162,181,228,176,218,104,194,171,57,215,10,229,185,248,159,128,174,89,110,82,9,113,31,117,138,124]}}},{"call":{"executed":{"scalar":{"error":[],"signature":[[46,237,145,48,205,81,157,67,138,18,123,52,97,179,239,150,95,99,40,109,73,202,16,45,143,215,226,220,134,187,115,232,209,82,52,239,91,189,190,188,68,71,176,95,126,78,9,56,212,166,220,170,12,217,192,86,87,123,70,135,110,140,190,3]],"success":true}}}},{"call":{"executed":{"scalar":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y"}}},{"call":{"executed":{"scalar":"HKcBpwGQVs5JgV4gii2ExEYD3nKuQdxsykSvFcXxR5tLPhgaUCQp9ZngskJt"}}},{"call":{"executed":{"scalar":["12D3KooWEPTY3tZtDcm16fDFWxkS9xNNZh9xyfvWLoCcys9N9a7Q","12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA","12D3KooWFH8Lkew96pawup9m9N2Q9XNT3FQBAak8o5t57SKeCMFB","12D3KooWQSFrshDiG1cRrc9mufJuoYT3fXHiJXXURxvJdPVAp8YH","12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r","12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv","12D3KooWB4Rigrxc9dB4rsRMG1y7i5LLpDsjx7M4tRXaybE4pKak","12D3KooWKvG1PNzHPFyy9gY2tVxGQ1h6DQqbtNjBE436Tm43mntQ","12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","12D3KooWEhVjBkBELM4pwRsZQg2rdkaWZEebCBLHhu5QbsqcSrnm","12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf","12D3KooWLAH2KAy7APEqa9MGX3ozw6pW9Z2krFR8NT3S5KQE6LWh","12D3KooWA79TCwRW2zuYNNEGEqA3XvCCRHskSSpaDsBmEZ62iZb8"]}}},{"par":[46,0]},{"par":[1,44]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[5,38]},{"call":{"executed":{"scalar":1665582320}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","key_id":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y","success":true}}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[1,36]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[1,34]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[5,28]},{"call":{"executed":{"scalar":1665582320}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","key_id":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y","success":true}}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[5,22]},{"call":{"executed":{"scalar":1665582320}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","key_id":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y","success":true}}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[1,20]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[1,18]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[5,12]},{"call":{"executed":{"scalar":1665582320}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","key_id":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y","success":true}}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[1,10]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[5,4]},{"call":{"executed":{"scalar":1665582320}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","key_id":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y","success":true}}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[1,2]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[1,0]},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU"}},{"par":[7,1]},{"call":{"executed":{"scalar":0}}},{"fold":{"lore":[{"pos":31,"desc":[{"pos":74,"len":3},{"pos":77,"len":0}]}]}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":67}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":67}]}}},{"ap":{"gens":[0]}},{"call":{"sent_by":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 8"}},{"fold":{"lore":[{"pos":78,"desc":[{"pos":81,"len":3},{"pos":84,"len":0}]}]}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":""},"values":[{"result":"ok","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":90}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":""},"values":[{"result":"ok","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":90}]}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"trace_pos":93}]}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[{"result":"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y","tetraplet":{"function_name":"get_key_id","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":"registry"},"trace_pos":87}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[]}}},{"ap":{"gens":[0]}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":""},"values":[{"result":"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h","tetraplet":{"function_name":"upload","json_path":".$.[0]","peer_pk":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN","service_id":"ipfs_client"},"trace_pos":91}]}}},{"call":{"executed":{"scalar":{}}}},{"call":{"executed":{"scalar":1665582321}}},{"par":[0,1]},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":""},"values":[]}}},{"call":{"executed":{"scalar":[76,145,207,53,167,76,185,156,152,46,77,25,175,201,5,28,237,181,176,251,65,133,238,251,68,100,225,251,169,37,142,7]}}},{"call":{"executed":{"scalar":{"error":[],"signature":[[123,150,26,90,108,125,179,43,0,21,161,25,14,153,125,17,219,139,129,110,152,64,32,195,11,8,170,108,237,193,116,112,218,246,147,78,183,76,200,93,206,232,238,175,71,227,214,222,109,226,222,129,150,213,87,251,19,58,92,236,99,27,29,0]],"success":true}}}},{"par":[0,0]},{"call":{"sent_by":"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN"}}],"streams":{},"version":"0.2.2","lcid":9,"r_streams":{"$array-inline":{"322":[1]},"$array-inline-1":{"1622":[1]},"$successful_test":{"7190":[1]},"$result-2":{"6838":[1]},"$success-0":{"11837":[0]},"$cid":{"200":[1]},"$error-1":{"3486":[0]},"$error_reg":{"3457":[0]},"$error_get":{"11795":[0]},"$successful-0":{"11751":[0]},"$error-0":{"160":[0]},"$relay_id":{"11913":[0]},"$status":{"6796":[1]},"$error-4":{"12487":[0]},"$option-inline":{"11386":[1]},"$error":{"103":[0]},"$successful":{"3699":[1]},"$resource_id":{"3635":[1]},"$result-3":{"12577":[0]},"$error_cre":{"3534":[1]},"$status_test":{"8690":[1]}}}"#;
//const CURRENT_DATA: &str = r#"{"trace":[{"call":{"executed":{"scalar":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"}}},{"call":{"executed":{"scalar":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc"}}},{"call":{"executed":{"scalar":"some_value"}}},{"call":{"executed":{"scalar":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v"}}},{"call":{"executed":{"scalar":["id"]}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":1665506843}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","tetraplet":{"function_name":"-relay-","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":"getDataSrv"},"trace_pos":5}]}}},{"call":{"executed":{"scalar":[109,198,222,202,133,116,16,233,252,153,13,6,152,166,81,237,88,107,215,47,37,96,5,113,43,90,102,248,164,151,16,35]}}},{"call":{"executed":{"scalar":{"error":[],"signature":[[157,10,75,157,224,190,235,95,105,91,236,31,212,174,224,97,226,246,65,6,75,212,4,89,126,92,93,100,61,16,197,45,131,20,125,170,170,138,87,102,93,50,207,220,143,93,237,162,240,221,180,100,253,105,79,231,135,55,141,69,23,160,69,4]],"success":true}}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","tetraplet":{"function_name":"-relay-","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":"getDataSrv"},"trace_pos":5}]}}},{"call":{"executed":{"stream":{"value":{"issued_by":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","issuer_signature":[157,10,75,157,224,190,235,95,105,91,236,31,212,174,224,97,226,246,65,6,75,212,4,89,126,92,93,100,61,16,197,45,131,20,125,170,170,138,87,102,93,50,207,220,143,93,237,162,240,221,180,100,253,105,79,231,135,55,141,69,23,160,69,4],"key_id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","relay_id":["12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"],"service_id":["id"],"solution":[],"timestamp_issued":1665506843,"value":"some_value"},"generation":0}}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":{"issued_by":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","issuer_signature":[157,10,75,157,224,190,235,95,105,91,236,31,212,174,224,97,226,246,65,6,75,212,4,89,126,92,93,100,61,16,197,45,131,20,125,170,170,138,87,102,93,50,207,220,143,93,237,162,240,221,180,100,253,105,79,231,135,55,141,69,23,160,69,4],"key_id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","relay_id":["12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"],"service_id":["id"],"solution":[],"timestamp_issued":1665506843,"value":"some_value"},"tetraplet":{"function_name":"create_record_metadata","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":"registry"},"trace_pos":11}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[]}}},{"call":{"executed":{"scalar":1665506844}}},{"call":{"executed":{"scalar":[227,176,196,66,152,252,28,20,154,251,244,200,153,111,185,36,39,174,65,228,100,155,147,76,164,149,153,27,120,82,184,85]}}},{"call":{"executed":{"stream":{"value":{"error":[],"signature":[[231,8,196,58,49,131,29,64,40,242,102,12,151,190,220,169,65,66,93,195,106,200,42,25,178,112,183,67,74,242,113,74,73,112,108,55,0,70,98,2,254,151,132,238,127,180,64,104,254,223,35,170,47,236,174,68,172,201,245,103,109,169,53,14]],"success":true},"generation":0}}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":{"error":[],"signature":[[231,8,196,58,49,131,29,64,40,242,102,12,151,190,220,169,65,66,93,195,106,200,42,25,178,112,183,67,74,242,113,74,73,112,108,55,0,70,98,2,254,151,132,238,127,180,64,104,254,223,35,170,47,236,174,68,172,201,245,103,109,169,53,14]],"success":true},"tetraplet":{"function_name":"sign","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":"sig"},"trace_pos":16}]}}},{"call":{"executed":{"scalar":"KJEWoy9Us5mFyUUqx5Ukzr7KKGgwrgu14oY6Ai67J5rLMAbERadtSeQz8AZQ"}}},{"call":{"executed":{"scalar":["12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv","12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r","12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA","12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf"]}}},{"par":[25,0]},{"par":[4,20]},{"call":{"executed":{"scalar":{"error":"","key":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"success":true}}}},{"ap":{"gens":[3]}},{"ap":{"gens":[3]}},{"call":{"executed":{"scalar":""}}},{"par":[4,15]},{"call":{"executed":{"scalar":{"error":"","key":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"success":true}}}},{"ap":{"gens":[4]}},{"ap":{"gens":[4]}},{"call":{"executed":{"scalar":""}}},{"par":[4,10]},{"call":{"executed":{"scalar":{"error":"","key":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"success":true}}}},{"ap":{"gens":[2]}},{"ap":{"gens":[2]}},{"call":{"executed":{"scalar":""}}},{"par":[4,5]},{"call":{"executed":{"scalar":{"error":"","key":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"success":true}}}},{"ap":{"gens":[1]}},{"ap":{"gens":[1]}},{"call":{"executed":{"scalar":""}}},{"par":[4,0]},{"call":{"executed":{"scalar":{"error":"","key":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"success":true}}}},{"ap":{"gens":[0]}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[19,1]},{"call":{"executed":{"scalar":0}}},{"fold":{"lore":[{"pos":44,"desc":[{"pos":49,"len":3},{"pos":52,"len":0}]},{"pos":39,"desc":[{"pos":52,"len":3},{"pos":55,"len":0}]},{"pos":34,"desc":[{"pos":55,"len":3},{"pos":58,"len":0}]},{"pos":24,"desc":[{"pos":58,"len":3},{"pos":61,"len":0}]},{"pos":29,"desc":[{"pos":61,"len":3},{"pos":64,"len":0}]}]}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":44}]}}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[1]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":47},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":50}]}}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[2]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":50},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":53},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":56}]}}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[3]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":50},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":53},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":56},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":59}]}}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[4]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":50},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":53},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":56},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":59},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":62}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":44}]}}},{"ap":{"gens":[0]}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE: 9"}},{"fold":{"lore":[{"pos":65,"desc":[{"pos":68,"len":3},{"pos":71,"len":0}]}]}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"ok","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":65}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"ok","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":65}]}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":68}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"tetraplet":{"function_name":"get_key_metadata","json_path":".$.key","peer_pk":"12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf","service_id":"registry"},"trace_pos":43},{"result":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"tetraplet":{"function_name":"get_key_metadata","json_path":".$.key","peer_pk":"12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA","service_id":"registry"},"trace_pos":38},{"result":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"tetraplet":{"function_name":"get_key_metadata","json_path":".$.key","peer_pk":"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","service_id":"registry"},"trace_pos":33},{"result":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"tetraplet":{"function_name":"get_key_metadata","json_path":".$.key","peer_pk":"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv","service_id":"registry"},"trace_pos":23},{"result":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"tetraplet":{"function_name":"get_key_metadata","json_path":".$.key","peer_pk":"12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r","service_id":"registry"},"trace_pos":28}]}}},{"call":{"executed":{"scalar":{"error":"","key":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"success":true}}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":{"challenge":[],"challenge_type":"","id":"8FivTFMUxqKUdd5jcKdngfdDYH23ko61WfWJB5Lm5sKc","label":"some_label","owner_peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","signature":[19,104,134,36,160,158,172,7,159,183,52,116,16,25,217,42,251,45,4,89,79,40,76,125,199,207,215,67,183,154,234,30,46,194,36,95,64,30,87,25,34,101,212,60,130,55,211,231,55,234,66,142,67,28,179,114,90,60,54,183,28,229,42,3],"timestamp_created":1665496440},"tetraplet":{"function_name":"merge_keys","json_path":".$.key","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":"registry"},"trace_pos":76}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[]}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"call":{"executed":{"scalar":""}}},{"call":{"executed":{"scalar":"KJEWoy9Us5mFyUUqx5Ukzr7KKGgwrgu14oY6Ai67J5rLMAbERadtSeQz8AZQ"}}},{"call":{"executed":{"scalar":["12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv","12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r","12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU","12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA","12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf"]}}},{"par":[50,0]},{"par":[9,40]},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"par":[0,0]},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"ap":{"gens":[2]}},{"call":{"executed":{"scalar":""}}},{"par":[9,30]},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"par":[0,0]},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"ap":{"gens":[4]}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE: 37"}},{"par":[9,20]},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"par":[0,0]},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"ap":{"gens":[0]}},{"call":{"executed":{"scalar":""}}},{"par":[9,10]},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"par":[0,0]},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"ap":{"gens":[1]}},{"call":{"executed":{"scalar":""}}},{"par":[9,0]},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"call":{"executed":{"scalar":1665506845}}},{"call":{"executed":{"scalar":{"error":"","peer_id":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","success":true,"weight":0}}}},{"par":[0,0]},{"call":{"executed":{"scalar":{"error":"","success":true}}}},{"ap":{"gens":[3]}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE: 35"}},{"par":[15,1]},{"call":{"executed":{"scalar":0}}},{"fold":{"lore":[{"pos":113,"desc":[{"pos":138,"len":3},{"pos":141,"len":0}]},{"pos":123,"desc":[{"pos":141,"len":3},{"pos":144,"len":0}]},{"pos":93,"desc":[{"pos":144,"len":3},{"pos":147,"len":0}]},{"pos":133,"desc":[{"pos":147,"len":1},{"pos":148,"len":0}]},{"pos":103,"desc":[{"pos":148,"len":1},{"pos":149,"len":0}]}]}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":123}]}}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[1]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":131},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":134}]}}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[2]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":139},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":142},{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":145}]}}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE: 36"}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE: 38"}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":123}]}}},{"ap":{"gens":[0]}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE: 27"}},{"fold":{"lore":[{"pos":150,"desc":[{"pos":153,"len":3},{"pos":156,"len":0}]}]}},{"call":{"executed":{"scalar":1}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"ok","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":154}]}}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":"ok","tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":154}]}}},{"ap":{"gens":[0]}},{"canon":{"canonicalized_element":{"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE","service_id":""},"values":[{"result":true,"tetraplet":{"function_name":"","json_path":"","peer_pk":"12D3KooWFTm82PPh3PVcMby2WvJgbCz59QPb7Zn9WEVQVFtiWF7v","service_id":""},"trace_pos":157}]}}},{"ap":{"gens":[0]}},{"fold":{"lore":[{"pos":159,"desc":[{"pos":161,"len":1},{"pos":162,"len":0}]}]}},{"call":{"sent_by":"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE"}}],"streams":{},"version":"0.2.2","lcid":38,"r_streams":{"$relay_id":{"570":[1]},"$signature":{"2927":[1]},"$successful-0_test":{"7972":[5]},"$result-1":{"7604":[1]},"$status-0_test":{"22208":[1]},"$status-0":{"20415":[1]},"$success_test":{"24131":[0]},"$status_test":{"9544":[1]},"$successful":{"476":[5]},"$status":{"7560":[1]},"$success":{"528":[1]},"$error_get":{"502":[1]},"$successful-0":{"5206":[5]},"$error-0":{"899":[0]},"$result":{"957":[1]},"$resources":{"5165":[5]},"$result-6":{"20456":[1]},"$successful_test":{"20786":[3]},"$result-0":{"5251":[1]}}}"#;
const CURRENT_DATA: &str = "{\n    \"trace\": [\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"will upload\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 1\n                        },\n                        {\n                            \"result\": \"/Users/folex/Development/fluencelabs/subrosy/src/scheduled/scheduled.simple.air\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 2\n                        },\n                        {\n                            \"result\": \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 3\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {}\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"multiaddr\": \"/ip4/134.209.186.43/tcp/5001/p2p/12D3KooWEhCqQ9NBnmtSfNeXSNfhgccmH86xodkCUxZNEXab6pkw\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"success\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 9\n                        },\n                        {\n                            \"result\": \"/ip4/134.209.186.43/tcp/5001/p2p/12D3KooWEhCqQ9NBnmtSfNeXSNfhgccmH86xodkCUxZNEXab6pkw\",\n                            \"tetraplet\": {\n                                \"function_name\": \"get_external_api_multiaddr\",\n                                \"json_path\": \".$.multiaddr\",\n                                \"peer_pk\": \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                                \"service_id\": \"aqua-ipfs\"\n                            },\n                            \"trace_pos\": 10\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {}\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h\"\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h\",\n                            \"tetraplet\": {\n                                \"function_name\": \"upload\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"ipfs_client\"\n                            },\n                            \"trace_pos\": 14\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": []\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {}\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582319\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": [\n                        124,\n                        177,\n                        64,\n                        18,\n                        168,\n                        199,\n                        162,\n                        181,\n                        228,\n                        176,\n                        218,\n                        104,\n                        194,\n                        171,\n                        57,\n                        215,\n                        10,\n                        229,\n                        185,\n                        248,\n                        159,\n                        128,\n                        174,\n                        89,\n                        110,\n                        82,\n                        9,\n                        113,\n                        31,\n                        117,\n                        138,\n                        124\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": [],\n                        \"signature\": [\n                            [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ]\n                        ],\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"HKcBpwGQVs5JgV4gii2ExEYD3nKuQdxsykSvFcXxR5tLPhgaUCQp9ZngskJt\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": [\n                        \"12D3KooWEPTY3tZtDcm16fDFWxkS9xNNZh9xyfvWLoCcys9N9a7Q\",\n                        \"12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA\",\n                        \"12D3KooWFH8Lkew96pawup9m9N2Q9XNT3FQBAak8o5t57SKeCMFB\",\n                        \"12D3KooWQSFrshDiG1cRrc9mufJuoYT3fXHiJXXURxvJdPVAp8YH\",\n                        \"12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r\",\n                        \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                        \"12D3KooWB4Rigrxc9dB4rsRMG1y7i5LLpDsjx7M4tRXaybE4pKak\",\n                        \"12D3KooWKvG1PNzHPFyy9gY2tVxGQ1h6DQqbtNjBE436Tm43mntQ\",\n                        \"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE\",\n                        \"12D3KooWEhVjBkBELM4pwRsZQg2rdkaWZEebCBLHhu5QbsqcSrnm\",\n                        \"12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf\",\n                        \"12D3KooWLAH2KAy7APEqa9MGX3ozw6pW9Z2krFR8NT3S5KQE6LWh\",\n                        \"12D3KooWA79TCwRW2zuYNNEGEqA3XvCCRHskSSpaDsBmEZ62iZb8\"\n                    ]\n                }\n            }\n        },\n        {\n            \"par\": [\n                46,\n                0\n            ]\n        },\n        {\n            \"par\": [\n                1,\n                44\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                5,\n                38\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582320\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                36\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                34\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                5,\n                28\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582320\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                5,\n                22\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582320\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    3\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                20\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                18\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                5,\n                12\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582320\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                10\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                5,\n                4\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582320\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    4\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                2\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                19,\n                1\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 0\n                }\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 31,\n                        \"desc\": [\n                            {\n                                \"pos\": 74,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 77,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 57,\n                        \"desc\": [\n                            {\n                                \"pos\": 77,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 80,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 41,\n                        \"desc\": [\n                            {\n                                \"pos\": 80,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 83,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 47,\n                        \"desc\": [\n                            {\n                                \"pos\": 83,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 86,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 65,\n                        \"desc\": [\n                            {\n                                \"pos\": 86,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 89,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 67\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 71\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 74\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 75\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 78\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 81\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    3\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 75\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 78\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 81\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 84\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    4\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 75\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 78\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 81\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 84\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 87\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 67\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 8\"\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 90,\n                        \"desc\": [\n                            {\n                                \"pos\": 93,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 96,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"ok\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 90\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"ok\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 90\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 93\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"tetraplet\": {\n                                \"function_name\": \"get_key_id\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                                \"service_id\": \"registry\"\n                            },\n                            \"trace_pos\": 87\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": []\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h\",\n                            \"tetraplet\": {\n                                \"function_name\": \"upload\",\n                                \"json_path\": \".$.[0]\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"ipfs_client\"\n                            },\n                            \"trace_pos\": 91\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {}\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582321\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                1\n            ]\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": []\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": [\n                        76,\n                        145,\n                        207,\n                        53,\n                        167,\n                        76,\n                        185,\n                        156,\n                        152,\n                        46,\n                        77,\n                        25,\n                        175,\n                        201,\n                        5,\n                        28,\n                        237,\n                        181,\n                        176,\n                        251,\n                        65,\n                        133,\n                        238,\n                        251,\n                        68,\n                        100,\n                        225,\n                        251,\n                        169,\n                        37,\n                        142,\n                        7\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": [],\n                        \"signature\": [\n                            [\n                                123,\n                                150,\n                                26,\n                                90,\n                                108,\n                                125,\n                                179,\n                                43,\n                                0,\n                                21,\n                                161,\n                                25,\n                                14,\n                                153,\n                                125,\n                                17,\n                                219,\n                                139,\n                                129,\n                                110,\n                                152,\n                                64,\n                                32,\n                                195,\n                                11,\n                                8,\n                                170,\n                                108,\n                                237,\n                                193,\n                                116,\n                                112,\n                                218,\n                                246,\n                                147,\n                                78,\n                                183,\n                                76,\n                                200,\n                                93,\n                                206,\n                                232,\n                                238,\n                                175,\n                                71,\n                                227,\n                                214,\n                                222,\n                                109,\n                                226,\n                                222,\n                                129,\n                                150,\n                                213,\n                                87,\n                                251,\n                                19,\n                                58,\n                                92,\n                                236,\n                                99,\n                                27,\n                                29,\n                                0\n                            ]\n                        ],\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                1\n            ]\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": []\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"stream\": {\n                        \"value\": {\n                            \"issued_by\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"issuer_signature\": [\n                                123,\n                                150,\n                                26,\n                                90,\n                                108,\n                                125,\n                                179,\n                                43,\n                                0,\n                                21,\n                                161,\n                                25,\n                                14,\n                                153,\n                                125,\n                                17,\n                                219,\n                                139,\n                                129,\n                                110,\n                                152,\n                                64,\n                                32,\n                                195,\n                                11,\n                                8,\n                                170,\n                                108,\n                                237,\n                                193,\n                                116,\n                                112,\n                                218,\n                                246,\n                                147,\n                                78,\n                                183,\n                                76,\n                                200,\n                                93,\n                                206,\n                                232,\n                                238,\n                                175,\n                                71,\n                                227,\n                                214,\n                                222,\n                                109,\n                                226,\n                                222,\n                                129,\n                                150,\n                                213,\n                                87,\n                                251,\n                                19,\n                                58,\n                                92,\n                                236,\n                                99,\n                                27,\n                                29,\n                                0\n                            ],\n                            \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"peer_id\": \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                            \"relay_id\": [],\n                            \"service_id\": [\n                                \"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h\"\n                            ],\n                            \"solution\": [],\n                            \"timestamp_issued\": 1665582321,\n                            \"value\": \"role=ipfs_healthcheck_script\"\n                        },\n                        \"generation\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": {\n                                \"issued_by\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"issuer_signature\": [\n                                    123,\n                                    150,\n                                    26,\n                                    90,\n                                    108,\n                                    125,\n                                    179,\n                                    43,\n                                    0,\n                                    21,\n                                    161,\n                                    25,\n                                    14,\n                                    153,\n                                    125,\n                                    17,\n                                    219,\n                                    139,\n                                    129,\n                                    110,\n                                    152,\n                                    64,\n                                    32,\n                                    195,\n                                    11,\n                                    8,\n                                    170,\n                                    108,\n                                    237,\n                                    193,\n                                    116,\n                                    112,\n                                    218,\n                                    246,\n                                    147,\n                                    78,\n                                    183,\n                                    76,\n                                    200,\n                                    93,\n                                    206,\n                                    232,\n                                    238,\n                                    175,\n                                    71,\n                                    227,\n                                    214,\n                                    222,\n                                    109,\n                                    226,\n                                    222,\n                                    129,\n                                    150,\n                                    213,\n                                    87,\n                                    251,\n                                    19,\n                                    58,\n                                    92,\n                                    236,\n                                    99,\n                                    27,\n                                    29,\n                                    0\n                                ],\n                                \"key_id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                                \"peer_id\": \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                                \"relay_id\": [],\n                                \"service_id\": [\n                                    \"QmZtGdmvC59fWxVGCnAkHaAXQR6LrgbWCPoPCuYFfLN53h\"\n                                ],\n                                \"solution\": [],\n                                \"timestamp_issued\": 1665582321,\n                                \"value\": \"role=ipfs_healthcheck_script\"\n                            },\n                            \"tetraplet\": {\n                                \"function_name\": \"create_record_metadata\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                                \"service_id\": \"registry\"\n                            },\n                            \"trace_pos\": 113\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": []\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582322\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": [\n                        227,\n                        176,\n                        196,\n                        66,\n                        152,\n                        252,\n                        28,\n                        20,\n                        154,\n                        251,\n                        244,\n                        200,\n                        153,\n                        111,\n                        185,\n                        36,\n                        39,\n                        174,\n                        65,\n                        228,\n                        100,\n                        155,\n                        147,\n                        76,\n                        164,\n                        149,\n                        153,\n                        27,\n                        120,\n                        82,\n                        184,\n                        85\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"stream\": {\n                        \"value\": {\n                            \"error\": [],\n                            \"signature\": [\n                                [\n                                    21,\n                                    63,\n                                    33,\n                                    138,\n                                    232,\n                                    233,\n                                    66,\n                                    102,\n                                    200,\n                                    8,\n                                    207,\n                                    109,\n                                    195,\n                                    144,\n                                    103,\n                                    1,\n                                    245,\n                                    165,\n                                    5,\n                                    178,\n                                    77,\n                                    252,\n                                    2,\n                                    229,\n                                    93,\n                                    215,\n                                    63,\n                                    68,\n                                    27,\n                                    62,\n                                    234,\n                                    249,\n                                    17,\n                                    108,\n                                    229,\n                                    52,\n                                    8,\n                                    56,\n                                    68,\n                                    202,\n                                    173,\n                                    33,\n                                    184,\n                                    70,\n                                    111,\n                                    95,\n                                    72,\n                                    43,\n                                    218,\n                                    16,\n                                    241,\n                                    25,\n                                    161,\n                                    255,\n                                    67,\n                                    63,\n                                    251,\n                                    145,\n                                    42,\n                                    74,\n                                    202,\n                                    248,\n                                    16,\n                                    2\n                                ]\n                            ],\n                            \"success\": true\n                        },\n                        \"generation\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": {\n                                \"error\": [],\n                                \"signature\": [\n                                    [\n                                        21,\n                                        63,\n                                        33,\n                                        138,\n                                        232,\n                                        233,\n                                        66,\n                                        102,\n                                        200,\n                                        8,\n                                        207,\n                                        109,\n                                        195,\n                                        144,\n                                        103,\n                                        1,\n                                        245,\n                                        165,\n                                        5,\n                                        178,\n                                        77,\n                                        252,\n                                        2,\n                                        229,\n                                        93,\n                                        215,\n                                        63,\n                                        68,\n                                        27,\n                                        62,\n                                        234,\n                                        249,\n                                        17,\n                                        108,\n                                        229,\n                                        52,\n                                        8,\n                                        56,\n                                        68,\n                                        202,\n                                        173,\n                                        33,\n                                        184,\n                                        70,\n                                        111,\n                                        95,\n                                        72,\n                                        43,\n                                        218,\n                                        16,\n                                        241,\n                                        25,\n                                        161,\n                                        255,\n                                        67,\n                                        63,\n                                        251,\n                                        145,\n                                        42,\n                                        74,\n                                        202,\n                                        248,\n                                        16,\n                                        2\n                                    ]\n                                ],\n                                \"success\": true\n                            },\n                            \"tetraplet\": {\n                                \"function_name\": \"sign\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                                \"service_id\": \"sig\"\n                            },\n                            \"trace_pos\": 118\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"HKcBpwGQVs5JgV4gii2ExEYD3nKuQdxsykSvFcXxR5tLPhgaUCQp9ZngskJt\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": [\n                        \"12D3KooWEPTY3tZtDcm16fDFWxkS9xNNZh9xyfvWLoCcys9N9a7Q\",\n                        \"12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA\",\n                        \"12D3KooWFH8Lkew96pawup9m9N2Q9XNT3FQBAak8o5t57SKeCMFB\",\n                        \"12D3KooWQSFrshDiG1cRrc9mufJuoYT3fXHiJXXURxvJdPVAp8YH\",\n                        \"12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r\",\n                        \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                        \"12D3KooWB4Rigrxc9dB4rsRMG1y7i5LLpDsjx7M4tRXaybE4pKak\",\n                        \"12D3KooWKvG1PNzHPFyy9gY2tVxGQ1h6DQqbtNjBE436Tm43mntQ\",\n                        \"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE\",\n                        \"12D3KooWEhVjBkBELM4pwRsZQg2rdkaWZEebCBLHhu5QbsqcSrnm\",\n                        \"12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf\",\n                        \"12D3KooWLAH2KAy7APEqa9MGX3ozw6pW9Z2krFR8NT3S5KQE6LWh\",\n                        \"12D3KooWA79TCwRW2zuYNNEGEqA3XvCCRHskSSpaDsBmEZ62iZb8\"\n                    ]\n                }\n            }\n        },\n        {\n            \"par\": [\n                41,\n                0\n            ]\n        },\n        {\n            \"par\": [\n                1,\n                39\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                4,\n                34\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key\": {\n                            \"challenge\": [],\n                            \"challenge_type\": \"\",\n                            \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"label\": \"folex\",\n                            \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"signature\": [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ],\n                            \"timestamp_created\": 1665582319\n                        },\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                32\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                30\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                4,\n                25\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key\": {\n                            \"challenge\": [],\n                            \"challenge_type\": \"\",\n                            \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"label\": \"folex\",\n                            \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"signature\": [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ],\n                            \"timestamp_created\": 1665582319\n                        },\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    4\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    4\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                4,\n                20\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key\": {\n                            \"challenge\": [],\n                            \"challenge_type\": \"\",\n                            \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"label\": \"folex\",\n                            \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"signature\": [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ],\n                            \"timestamp_created\": 1665582319\n                        },\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    3\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    3\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                18\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                16\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                4,\n                11\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key\": {\n                            \"challenge\": [],\n                            \"challenge_type\": \"\",\n                            \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"label\": \"folex\",\n                            \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"signature\": [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ],\n                            \"timestamp_created\": 1665582319\n                        },\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                9\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                4,\n                4\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key\": {\n                            \"challenge\": [],\n                            \"challenge_type\": \"\",\n                            \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"label\": \"folex\",\n                            \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"signature\": [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ],\n                            \"timestamp_created\": 1665582319\n                        },\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                2\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                19,\n                1\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 0\n                }\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 151,\n                        \"desc\": [\n                            {\n                                \"pos\": 167,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 170,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 158,\n                        \"desc\": [\n                            {\n                                \"pos\": 170,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 173,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 128,\n                        \"desc\": [\n                            {\n                                \"pos\": 173,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 176,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 142,\n                        \"desc\": [\n                            {\n                                \"pos\": 176,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 179,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 137,\n                        \"desc\": [\n                            {\n                                \"pos\": 179,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 182,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 159\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 162\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 165\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 165\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 168\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 171\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    3\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 168\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 171\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 174\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 177\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    4\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 168\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 171\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 174\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 177\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 180\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 159\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 27\"\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 183,\n                        \"desc\": [\n                            {\n                                \"pos\": 186,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 189,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"ok\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 173\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"ok\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 173\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 176\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": {\n                                \"challenge\": [],\n                                \"challenge_type\": \"\",\n                                \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                                \"label\": \"folex\",\n                                \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"signature\": [\n                                    46,\n                                    237,\n                                    145,\n                                    48,\n                                    205,\n                                    81,\n                                    157,\n                                    67,\n                                    138,\n                                    18,\n                                    123,\n                                    52,\n                                    97,\n                                    179,\n                                    239,\n                                    150,\n                                    95,\n                                    99,\n                                    40,\n                                    109,\n                                    73,\n                                    202,\n                                    16,\n                                    45,\n                                    143,\n                                    215,\n                                    226,\n                                    220,\n                                    134,\n                                    187,\n                                    115,\n                                    232,\n                                    209,\n                                    82,\n                                    52,\n                                    239,\n                                    91,\n                                    189,\n                                    190,\n                                    188,\n                                    68,\n                                    71,\n                                    176,\n                                    95,\n                                    126,\n                                    78,\n                                    9,\n                                    56,\n                                    212,\n                                    166,\n                                    220,\n                                    170,\n                                    12,\n                                    217,\n                                    192,\n                                    86,\n                                    87,\n                                    123,\n                                    70,\n                                    135,\n                                    110,\n                                    140,\n                                    190,\n                                    3\n                                ],\n                                \"timestamp_created\": 1665582319\n                            },\n                            \"tetraplet\": {\n                                \"function_name\": \"get_key_metadata\",\n                                \"json_path\": \".$.key\",\n                                \"peer_pk\": \"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE\",\n                                \"service_id\": \"registry\"\n                            },\n                            \"trace_pos\": 144\n                        },\n                        {\n                            \"result\": {\n                                \"challenge\": [],\n                                \"challenge_type\": \"\",\n                                \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                                \"label\": \"folex\",\n                                \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"signature\": [\n                                    46,\n                                    237,\n                                    145,\n                                    48,\n                                    205,\n                                    81,\n                                    157,\n                                    67,\n                                    138,\n                                    18,\n                                    123,\n                                    52,\n                                    97,\n                                    179,\n                                    239,\n                                    150,\n                                    95,\n                                    99,\n                                    40,\n                                    109,\n                                    73,\n                                    202,\n                                    16,\n                                    45,\n                                    143,\n                                    215,\n                                    226,\n                                    220,\n                                    134,\n                                    187,\n                                    115,\n                                    232,\n                                    209,\n                                    82,\n                                    52,\n                                    239,\n                                    91,\n                                    189,\n                                    190,\n                                    188,\n                                    68,\n                                    71,\n                                    176,\n                                    95,\n                                    126,\n                                    78,\n                                    9,\n                                    56,\n                                    212,\n                                    166,\n                                    220,\n                                    170,\n                                    12,\n                                    217,\n                                    192,\n                                    86,\n                                    87,\n                                    123,\n                                    70,\n                                    135,\n                                    110,\n                                    140,\n                                    190,\n                                    3\n                                ],\n                                \"timestamp_created\": 1665582319\n                            },\n                            \"tetraplet\": {\n                                \"function_name\": \"get_key_metadata\",\n                                \"json_path\": \".$.key\",\n                                \"peer_pk\": \"12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf\",\n                                \"service_id\": \"registry\"\n                            },\n                            \"trace_pos\": 151\n                        },\n                        {\n                            \"result\": {\n                                \"challenge\": [],\n                                \"challenge_type\": \"\",\n                                \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                                \"label\": \"folex\",\n                                \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"signature\": [\n                                    46,\n                                    237,\n                                    145,\n                                    48,\n                                    205,\n                                    81,\n                                    157,\n                                    67,\n                                    138,\n                                    18,\n                                    123,\n                                    52,\n                                    97,\n                                    179,\n                                    239,\n                                    150,\n                                    95,\n                                    99,\n                                    40,\n                                    109,\n                                    73,\n                                    202,\n                                    16,\n                                    45,\n                                    143,\n                                    215,\n                                    226,\n                                    220,\n                                    134,\n                                    187,\n                                    115,\n                                    232,\n                                    209,\n                                    82,\n                                    52,\n                                    239,\n                                    91,\n                                    189,\n                                    190,\n                                    188,\n                                    68,\n                                    71,\n                                    176,\n                                    95,\n                                    126,\n                                    78,\n                                    9,\n                                    56,\n                                    212,\n                                    166,\n                                    220,\n                                    170,\n                                    12,\n                                    217,\n                                    192,\n                                    86,\n                                    87,\n                                    123,\n                                    70,\n                                    135,\n                                    110,\n                                    140,\n                                    190,\n                                    3\n                                ],\n                                \"timestamp_created\": 1665582319\n                            },\n                            \"tetraplet\": {\n                                \"function_name\": \"get_key_metadata\",\n                                \"json_path\": \".$.key\",\n                                \"peer_pk\": \"12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA\",\n                                \"service_id\": \"registry\"\n                            },\n                            \"trace_pos\": 127\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"key\": {\n                            \"challenge\": [],\n                            \"challenge_type\": \"\",\n                            \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                            \"label\": \"folex\",\n                            \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                            \"signature\": [\n                                46,\n                                237,\n                                145,\n                                48,\n                                205,\n                                81,\n                                157,\n                                67,\n                                138,\n                                18,\n                                123,\n                                52,\n                                97,\n                                179,\n                                239,\n                                150,\n                                95,\n                                99,\n                                40,\n                                109,\n                                73,\n                                202,\n                                16,\n                                45,\n                                143,\n                                215,\n                                226,\n                                220,\n                                134,\n                                187,\n                                115,\n                                232,\n                                209,\n                                82,\n                                52,\n                                239,\n                                91,\n                                189,\n                                190,\n                                188,\n                                68,\n                                71,\n                                176,\n                                95,\n                                126,\n                                78,\n                                9,\n                                56,\n                                212,\n                                166,\n                                220,\n                                170,\n                                12,\n                                217,\n                                192,\n                                86,\n                                87,\n                                123,\n                                70,\n                                135,\n                                110,\n                                140,\n                                190,\n                                3\n                            ],\n                            \"timestamp_created\": 1665582319\n                        },\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": {\n                                \"challenge\": [],\n                                \"challenge_type\": \"\",\n                                \"id\": \"22W82ngsR4tBQXgXJZxu9SJyJMZxSfzEhQQhsdYDpN4y\",\n                                \"label\": \"folex\",\n                                \"owner_peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"signature\": [\n                                    46,\n                                    237,\n                                    145,\n                                    48,\n                                    205,\n                                    81,\n                                    157,\n                                    67,\n                                    138,\n                                    18,\n                                    123,\n                                    52,\n                                    97,\n                                    179,\n                                    239,\n                                    150,\n                                    95,\n                                    99,\n                                    40,\n                                    109,\n                                    73,\n                                    202,\n                                    16,\n                                    45,\n                                    143,\n                                    215,\n                                    226,\n                                    220,\n                                    134,\n                                    187,\n                                    115,\n                                    232,\n                                    209,\n                                    82,\n                                    52,\n                                    239,\n                                    91,\n                                    189,\n                                    190,\n                                    188,\n                                    68,\n                                    71,\n                                    176,\n                                    95,\n                                    126,\n                                    78,\n                                    9,\n                                    56,\n                                    212,\n                                    166,\n                                    220,\n                                    170,\n                                    12,\n                                    217,\n                                    192,\n                                    86,\n                                    87,\n                                    123,\n                                    70,\n                                    135,\n                                    110,\n                                    140,\n                                    190,\n                                    3\n                                ],\n                                \"timestamp_created\": 1665582319\n                            },\n                            \"tetraplet\": {\n                                \"function_name\": \"merge_keys\",\n                                \"json_path\": \".$.key\",\n                                \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                                \"service_id\": \"registry\"\n                            },\n                            \"trace_pos\": 190\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": []\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582322\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582322\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"HKcBpwGQVs5JgV4gii2ExEYD3nKuQdxsykSvFcXxR5tLPhgaUCQp9ZngskJt\"\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": [\n                        \"12D3KooWEPTY3tZtDcm16fDFWxkS9xNNZh9xyfvWLoCcys9N9a7Q\",\n                        \"12D3KooWAKNos2KogexTXhrkMZzFYpLHuWJ4PgoAhurSAv7o5CWA\",\n                        \"12D3KooWFH8Lkew96pawup9m9N2Q9XNT3FQBAak8o5t57SKeCMFB\",\n                        \"12D3KooWQSFrshDiG1cRrc9mufJuoYT3fXHiJXXURxvJdPVAp8YH\",\n                        \"12D3KooWDcpWuyrMTDinqNgmXAuRdfd2mTdY9VoXZSAet2pDzh6r\",\n                        \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\",\n                        \"12D3KooWB4Rigrxc9dB4rsRMG1y7i5LLpDsjx7M4tRXaybE4pKak\",\n                        \"12D3KooWKvG1PNzHPFyy9gY2tVxGQ1h6DQqbtNjBE436Tm43mntQ\",\n                        \"12D3KooWJ4bTHirdTFNZpCS72TAzwtdmavTBkkEXtzo6wHL25CtE\",\n                        \"12D3KooWEhVjBkBELM4pwRsZQg2rdkaWZEebCBLHhu5QbsqcSrnm\",\n                        \"12D3KooWMMGdfVEJ1rWe1nH1nehYDzNEHhg5ogdfiGk88AupCMnf\",\n                        \"12D3KooWLAH2KAy7APEqa9MGX3ozw6pW9Z2krFR8NT3S5KQE6LWh\",\n                        \"12D3KooWA79TCwRW2zuYNNEGEqA3XvCCRHskSSpaDsBmEZ62iZb8\"\n                    ]\n                }\n            }\n        },\n        {\n            \"par\": [\n                66,\n                0\n            ]\n        },\n        {\n            \"par\": [\n                1,\n                64\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                9,\n                54\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                52\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                50\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                9,\n                40\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                9,\n                30\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    4\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 54\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                28\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                26\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                9,\n                16\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": \"\"\n                }\n            }\n        },\n        {\n            \"par\": [\n                1,\n                14\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                9,\n                4\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1665582323\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"peer_id\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                        \"success\": true,\n                        \"weight\": 0\n                    }\n                }\n            }\n        },\n        {\n            \"par\": [\n                0,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": {\n                        \"error\": \"\",\n                        \"success\": true\n                    }\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    3\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 52\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                2\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                1,\n                0\n            ]\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        },\n        {\n            \"par\": [\n                15,\n                1\n            ]\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 0\n                }\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 258,\n                        \"desc\": [\n                            {\n                                \"pos\": 279,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 282,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 234,\n                        \"desc\": [\n                            {\n                                \"pos\": 282,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 285,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 220,\n                        \"desc\": [\n                            {\n                                \"pos\": 285,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 288,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 270,\n                        \"desc\": [\n                            {\n                                \"pos\": 288,\n                                \"len\": 1\n                            },\n                            {\n                                \"pos\": 289,\n                                \"len\": 0\n                            }\n                        ]\n                    },\n                    {\n                        \"pos\": 244,\n                        \"desc\": [\n                            {\n                                \"pos\": 289,\n                                \"len\": 1\n                            },\n                            {\n                                \"pos\": 290,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 264\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    1\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 272\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 275\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    2\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 280\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 283\n                        },\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 286\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 53\"\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 55\"\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 264\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU: 44\"\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 291,\n                        \"desc\": [\n                            {\n                                \"pos\": 294,\n                                \"len\": 3\n                            },\n                            {\n                                \"pos\": 297,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"executed\": {\n                    \"scalar\": 1\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"ok\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 295\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": \"ok\",\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 295\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"canon\": {\n                \"canonicalized_element\": {\n                    \"tetraplet\": {\n                        \"function_name\": \"\",\n                        \"json_path\": \"\",\n                        \"peer_pk\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\",\n                        \"service_id\": \"\"\n                    },\n                    \"values\": [\n                        {\n                            \"result\": true,\n                            \"tetraplet\": {\n                                \"function_name\": \"\",\n                                \"json_path\": \"\",\n                                \"peer_pk\": \"12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN\",\n                                \"service_id\": \"\"\n                            },\n                            \"trace_pos\": 298\n                        }\n                    ]\n                }\n            }\n        },\n        {\n            \"ap\": {\n                \"gens\": [\n                    0\n                ]\n            }\n        },\n        {\n            \"fold\": {\n                \"lore\": [\n                    {\n                        \"pos\": 300,\n                        \"desc\": [\n                            {\n                                \"pos\": 302,\n                                \"len\": 1\n                            },\n                            {\n                                \"pos\": 303,\n                                \"len\": 0\n                            }\n                        ]\n                    }\n                ]\n            }\n        },\n        {\n            \"call\": {\n                \"sent_by\": \"12D3KooWMigkP4jkVyufq5JnDJL6nXvyjeaDNpRfEZqQhsG3sYCU\"\n            }\n        }\n    ],\n    \"streams\": {},\n    \"version\": \"0.2.2\",\n    \"lcid\": 55,\n    \"r_streams\": {\n        \"$successful\": {\n            \"3699\": [\n                5\n            ]\n        },\n        \"$successful-1\": {\n            \"19028\": [\n                5\n            ]\n        },\n        \"$array-inline\": {\n            \"322\": [\n                1\n            ]\n        },\n        \"$status\": {\n            \"6796\": [\n                1\n            ]\n        },\n        \"$result-5\": {\n            \"22683\": [\n                1\n            ]\n        },\n        \"$resources\": {\n            \"18971\": [\n                5\n            ]\n        },\n        \"$error_reg\": {\n            \"3457\": [\n                0\n            ]\n        },\n        \"$array-inline-1\": {\n            \"1622\": [\n                1\n            ]\n        },\n        \"$status-0\": {\n            \"22621\": [\n                1\n            ]\n        },\n        \"$error_get\": {\n            \"11795\": [\n                1\n            ]\n        },\n        \"$signature\": {\n            \"15920\": [\n                1\n            ]\n        },\n        \"$result-10\": {\n            \"40401\": [\n                1\n            ]\n        },\n        \"$success-0_test\": {\n            \"45426\": [\n                0\n            ]\n        },\n        \"$successful_test\": {\n            \"7190\": [\n                5\n            ]\n        },\n        \"$cid\": {\n            \"200\": [\n                1\n            ]\n        },\n        \"$error\": {\n            \"103\": [\n                0\n            ]\n        },\n        \"$result-4\": {\n            \"19089\": [\n                1\n            ]\n        },\n        \"$successful-0_test\": {\n            \"40860\": [\n                3\n            ]\n        },\n        \"$error_cre\": {\n            \"3534\": [\n                1\n            ]\n        },\n        \"$status-1\": {\n            \"40344\": [\n                1\n            ]\n        },\n        \"$result-2\": {\n            \"6838\": [\n                1\n            ]\n        },\n        \"$status-0_test\": {\n            \"25207\": [\n                1\n            ]\n        },\n        \"$resource_id\": {\n            \"3635\": [\n                1\n            ]\n        },\n        \"$option-inline\": {\n            \"11386\": [\n                1\n            ]\n        },\n        \"$result-3\": {\n            \"12577\": [\n                1\n            ]\n        },\n        \"$error-0\": {\n            \"160\": [\n                0\n            ]\n        },\n        \"$relay_id\": {\n            \"11913\": [\n                0\n            ]\n        },\n        \"$status_test\": {\n            \"8690\": [\n                1\n            ]\n        },\n        \"$success-0\": {\n            \"11837\": [\n                1\n            ]\n        },\n        \"$successful-0\": {\n            \"11751\": [\n                5\n            ]\n        },\n        \"$error-4\": {\n            \"12487\": [\n                0\n            ]\n        },\n        \"$successful-1_test\": {\n            \"23181\": [\n                5\n            ]\n        },\n        \"$status-1_test\": {\n            \"42746\": [\n                1\n            ]\n        },\n        \"$error-1\": {\n            \"3486\": [\n                0\n            ]\n        }\n    }\n}";

//https://github.com/fluencelabs/aquavm/issues/363
#[test]
fn issue_999() {
    let peer_id = "peer_id";
    let mut vm = create_avm(echo_call_service(), peer_id);

    //let script = "(xor\n (seq\n  (seq\n   (seq\n    (seq\n     (seq\n      (seq\n       (seq\n        (seq\n         (seq\n          (seq\n           (seq\n            (call %init_peer_id% (\"getDataSrv\" \"-relay-\") [] -relay-)\n            (call %init_peer_id% (\"getDataSrv\" \"a\") [] a)\n           )\n           (call %init_peer_id% (\"getDataSrv\" \"b\") [] b)\n          )\n          (call %init_peer_id% (\"getDataSrv\" \"c\") [] c)\n         )\n         (call %init_peer_id% (\"getDataSrv\" \"d\") [] d)\n        )\n        (new $successful\n         (new $error_get\n          (new $success\n           (seq\n            (new $relay_id\n             (seq\n              (seq\n               (seq\n                (xor\n                 (match c %init_peer_id%\n                  (ap -relay- $relay_id)\n                 )\n                 (call %init_peer_id% (\"op\" \"noop\") [])\n                )\n                (xor\n                 (seq\n                  (new $error-0\n                   (seq\n                    (new $result\n                     (seq\n                      (seq\n                       (seq\n                        (seq\n                         (seq\n                          (call -relay- (\"peer\" \"timestamp_sec\") [] t-0)\n                          (canon -relay- $relay_id  #relay_id_canon)\n                         )\n                         (call -relay- (\"registry\" \"get_record_metadata_bytes\") [a %init_peer_id% t-0 b c #relay_id_canon d []] bytes)\n                        )\n                        (xor\n                         (call %init_peer_id% (\"sig\" \"sign\") [bytes] sig_result)\n                         (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 1])\n                        )\n                       )\n                       (xor\n                        (match sig_result.$.success! true\n                         (xor\n                          (seq\n                           (canon -relay- $relay_id  #relay_id_canon-0)\n                           (call -relay- (\"registry\" \"create_record_metadata\") [a %init_peer_id% t-0 b c #relay_id_canon-0 d [] sig_result.$.signature.[0]!] $result)\n                          )\n                          (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 2])\n                         )\n                        )\n                        (ap sig_result.$.error.[0]! $error-0)\n                       )\n                      )\n                      (canon -relay- $result  #result-fix)\n                     )\n                    )\n                    (canon -relay- $error-0  #error-fix)\n                   )\n                  )\n                  (xor\n                   (match #result-fix []\n                    (seq\n                     (ap false $success)\n                     (ap #error-fix.$.[0]! $error)\n                    )\n                   )\n                   (seq\n                    (seq\n                     (call -relay- (\"peer\" \"timestamp_sec\") [] t)\n                     (new $signature\n                      (seq\n                       (xor\n                        (mismatch #result-fix.$.[0].peer_id! %init_peer_id%\n                         (xor\n                          (xor\n                           (seq\n                            (seq\n                             (ap #result-fix.$.[0]! result-fix_flatten)\n                             (call #result-fix.$.[0].peer_id! (\"registry\" \"get_record_bytes\") [result-fix_flatten t] bytes-0)\n                            )\n                            (call #result-fix.$.[0].peer_id! (\"sig\" \"sign\") [bytes-0] $signature)\n                           )\n                           (seq\n                            (call -relay- (\"op\" \"noop\") [])\n                            (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 3])\n                           )\n                          )\n                          (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 4])\n                         )\n                        )\n                        (xor\n                         (seq\n                          (seq\n                           (ap #result-fix.$.[0]! result-fix_flatten-0)\n                           (call -relay- (\"registry\" \"get_record_bytes\") [result-fix_flatten-0 t] bytess)\n                          )\n                          (xor\n                           (call %init_peer_id% (\"sig\" \"sign\") [bytess] $signature)\n                           (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 5])\n                          )\n                         )\n                         (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 6])\n                        )\n                       )\n                       (canon -relay- $signature  #signature-fix)\n                      )\n                     )\n                    )\n                    (xor\n                     (match #signature-fix.$.[0].success! false\n                      (seq\n                       (ap #signature-fix.$.[0].error.[0]! $error)\n                       (ap false $success)\n                      )\n                     )\n                     (seq\n                      (seq\n                       (seq\n                        (new $resources\n                         (new $successful-0\n                          (new $result-0\n                           (seq\n                            (seq\n                             (seq\n                              (seq\n                               (seq\n                                (call -relay- (\"op\" \"string_to_b58\") [a] k)\n                                (call -relay- (\"kad\" \"neighborhood\") [k [] []] nodes-1)\n                               )\n                               (par\n                                (fold nodes-1 n-0-0\n                                 (par\n                                  (seq\n                                   (xor\n                                    (xor\n                                     (seq\n                                      (call n-0-0 (\"registry\" \"get_key_metadata\") [a] get_result)\n                                      (xor\n                                       (match get_result.$.success! true\n                                        (seq\n                                         (ap get_result.$.key! $resources)\n                                         (ap true $successful-0)\n                                        )\n                                       )\n                                       (seq\n                                        (call n-0-0 (\"op\" \"concat_strings\") [get_result.$.error! \" on \"] e)\n                                        (call n-0-0 (\"op\" \"concat_strings\") [e n-0-0] $error-1)\n                                       )\n                                      )\n                                     )\n                                     (call n-0-0 (\"op\" \"noop\") [])\n                                    )\n                                    (seq\n                                     (call -relay- (\"op\" \"noop\") [])\n                                     (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 7])\n                                    )\n                                   )\n                                   (call -relay- (\"op\" \"noop\") [])\n                                  )\n                                  (next n-0-0)\n                                 )\n                                 (never)\n                                )\n                                (null)\n                               )\n                              )\n                              (new $status\n                               (new $result-1\n                                (seq\n                                 (seq\n                                  (seq\n                                   (par\n                                    (seq\n                                     (seq\n                                      (call -relay- (\"math\" \"sub\") [1 1] sub)\n                                      (new $successful-0_test\n                                       (seq\n                                        (fold $successful-0 s\n                                         (seq\n                                          (seq\n                                           (seq\n                                            (call -relay- (\"math\" \"add\") [sub 1] incr_idx)\n                                            (ap s $successful-0_test)\n                                           )\n                                           (canon -relay- $successful-0_test  #successful-0_iter_canon)\n                                          )\n                                          (xor\n                                           (match #successful-0_iter_canon.length incr_idx\n                                            (null)\n                                           )\n                                           (next s)\n                                          )\n                                         )\n                                         (never)\n                                        )\n                                        (canon -relay- $successful-0_test  #successful-0_result_canon)\n                                       )\n                                      )\n                                     )\n                                     (ap \"ok\" $status)\n                                    )\n                                    (call -relay- (\"peer\" \"timeout\") [6000 \"timeout\"] $status)\n                                   )\n                                   (new $status_test\n                                    (seq\n                                     (fold $status s\n                                      (seq\n                                       (seq\n                                        (seq\n                                         (call -relay- (\"math\" \"add\") [0 1] incr_idx)\n                                         (ap s $status_test)\n                                        )\n                                        (canon -relay- $status_test  #status_iter_canon)\n                                       )\n                                       (xor\n                                        (match #status_iter_canon.length incr_idx\n                                         (null)\n                                        )\n                                        (next s)\n                                       )\n                                      )\n                                      (never)\n                                     )\n                                     (canon -relay- $status_test  #status_result_canon)\n                                    )\n                                   )\n                                  )\n                                  (xor\n                                   (match #status_result_canon.$.[0]! \"ok\"\n                                    (ap true $result-1)\n                                   )\n                                   (ap false $result-1)\n                                  )\n                                 )\n                                 (canon -relay- $result-1  #result-fix-1)\n                                )\n                               )\n                              )\n                             )\n                             (xor\n                              (match #result-fix-1.$.[0]! false\n                               (ap \"resource not found: timeout exceeded\" $error-1)\n                              )\n                              (seq\n                               (seq\n                                (canon -relay- $resources  #resources_canon)\n                                (call -relay- (\"registry\" \"merge_keys\") [#resources_canon] merge_result)\n                               )\n                               (xor\n                                (match merge_result.$.success! true\n                                 (ap merge_result.$.key! $result-0)\n                                )\n                                (ap merge_result.$.error! $error-1)\n                               )\n                              )\n                             )\n                            )\n                            (canon -relay- $result-0  #result-fix-0)\n                           )\n                          )\n                         )\n                        )\n                        (canon -relay- $error-1  #push-to-stream-106)\n                       )\n                       (ap #push-to-stream-106 $error_get)\n                      )\n                      (xor\n                       (match #result-fix-0 []\n                        (xor\n                         (seq\n                          (seq\n                           (canon -relay- $error_get  #error_get_canon)\n                           (fold #error_get_canon e-0-0\n                            (seq\n                             (ap e-0-0 $error)\n                             (next e-0-0)\n                            )\n                           )\n                          )\n                          (ap false $success)\n                         )\n                         (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 8])\n                        )\n                       )\n                       (seq\n                        (seq\n                         (seq\n                          (seq\n                           (seq\n                            (seq\n                             (call -relay- (\"op\" \"noop\") [])\n                             (xor\n                              (mismatch c %init_peer_id%\n                               (xor\n                                (xor\n                                 (seq\n                                  (seq\n                                   (seq\n                                    (seq\n                                     (seq\n                                      (call c (\"peer\" \"timestamp_sec\") [] t-1)\n                                      (ap #result-fix-0.$.[0].owner_peer_id! result-fix-0_flatten)\n                                     )\n                                     (call c (\"trust-graph\" \"get_weight\") [result-fix-0_flatten t-1] weight)\n                                    )\n                                    (ap #result-fix-0.$.[0]! result-fix-0_flatten-0)\n                                   )\n                                   (call c (\"registry\" \"republish_key\") [result-fix-0_flatten-0 weight t-1] result-2)\n                                  )\n                                  (xor\n                                   (match result-2.$.success! false\n                                    (ap result-2.$.error! $error)\n                                   )\n                                   (seq\n                                    (seq\n                                     (seq\n                                      (seq\n                                       (seq\n                                        (call c (\"peer\" \"timestamp_sec\") [] t-2)\n                                        (ap #result-fix.$.[0].issued_by! result-fix_flatten-1)\n                                       )\n                                       (call c (\"trust-graph\" \"get_weight\") [result-fix_flatten-1 t-2] weight-0)\n                                      )\n                                      (par\n                                       (ap #result-fix.$.[0]! result-fix_flatten-2)\n                                       (ap #signature-fix.$.[0].signature.[0]! signature-fix_flatten)\n                                      )\n                                     )\n                                     (call c (\"registry\" \"put_record\") [result-fix_flatten-2 t signature-fix_flatten weight-0 t-2] result-3)\n                                    )\n                                    (xor\n                                     (match result-3.$.success! false\n                                      (seq\n                                       (ap result-3.$.error! $error)\n                                       (ap false $success)\n                                      )\n                                     )\n                                     (call c (\"op\" \"noop\") [])\n                                    )\n                                   )\n                                  )\n                                 )\n                                 (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 9])\n                                )\n                                (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 10])\n                               )\n                              )\n                              (call -relay- (\"op\" \"noop\") [])\n                             )\n                            )\n                            (call -relay- (\"op\" \"string_to_b58\") [a] k-0)\n                           )\n                           (call -relay- (\"kad\" \"neighborhood\") [k-0 [] []] nodes)\n                          )\n                          (par\n                           (fold nodes n-1\n                            (par\n                             (seq\n                              (xor\n                               (xor\n                                (seq\n                                 (seq\n                                  (seq\n                                   (seq\n                                    (seq\n                                     (call n-1 (\"peer\" \"timestamp_sec\") [] t-3)\n                                     (ap #result-fix-0.$.[0].owner_peer_id! result-fix-0_flatten-1)\n                                    )\n                                    (call n-1 (\"trust-graph\" \"get_weight\") [result-fix-0_flatten-1 t-3] weight-1)\n                                   )\n                                   (ap #result-fix-0.$.[0]! result-fix-0_flatten-2)\n                                  )\n                                  (call n-1 (\"registry\" \"republish_key\") [result-fix-0_flatten-2 weight-1 t-3] result-4)\n                                 )\n                                 (xor\n                                  (match result-4.$.success! false\n                                   (ap result-4.$.error! $error)\n                                  )\n                                  (seq\n                                   (seq\n                                    (seq\n                                     (seq\n                                      (seq\n                                       (call n-1 (\"peer\" \"timestamp_sec\") [] t-4)\n                                       (ap #result-fix.$.[0].issued_by! result-fix_flatten-3)\n                                      )\n                                      (call n-1 (\"trust-graph\" \"get_weight\") [result-fix_flatten-3 t-4] weight-2)\n                                     )\n                                     (par\n                                      (ap #result-fix.$.[0]! result-fix_flatten-4)\n                                      (ap #signature-fix.$.[0].signature.[0]! signature-fix_flatten-0)\n                                     )\n                                    )\n                                    (call n-1 (\"registry\" \"put_record\") [result-fix_flatten-4 t signature-fix_flatten-0 weight-2 t-4] result-5)\n                                   )\n                                   (xor\n                                    (match result-5.$.success! true\n                                     (ap true $successful)\n                                    )\n                                    (ap result-5.$.error! $error)\n                                   )\n                                  )\n                                 )\n                                )\n                                (call n-1 (\"op\" \"noop\") [])\n                               )\n                               (seq\n                                (call -relay- (\"op\" \"noop\") [])\n                                (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 11])\n                               )\n                              )\n                              (call -relay- (\"op\" \"noop\") [])\n                             )\n                             (next n-1)\n                            )\n                            (never)\n                           )\n                           (null)\n                          )\n                         )\n                         (new $status-0\n                          (new $result-6\n                           (seq\n                            (seq\n                             (seq\n                              (par\n                               (seq\n                                (seq\n                                 (call -relay- (\"math\" \"sub\") [1 1] sub-0)\n                                 (new $successful_test\n                                  (seq\n                                   (fold $successful s\n                                    (seq\n                                     (seq\n                                      (seq\n                                       (call -relay- (\"math\" \"add\") [sub-0 1] incr_idx)\n                                       (ap s $successful_test)\n                                      )\n                                      (canon -relay- $successful_test  #successful_iter_canon)\n                                     )\n                                     (xor\n                                      (match #successful_iter_canon.length incr_idx\n                                       (null)\n                                      )\n                                      (next s)\n                                     )\n                                    )\n                                    (never)\n                                   )\n                                   (canon -relay- $successful_test  #successful_result_canon)\n                                  )\n                                 )\n                                )\n                                (ap \"ok\" $status-0)\n                               )\n                               (call -relay- (\"peer\" \"timeout\") [6000 \"timeout\"] $status-0)\n                              )\n                              (new $status-0_test\n                               (seq\n                                (fold $status-0 s\n                                 (seq\n                                  (seq\n                                   (seq\n                                    (call -relay- (\"math\" \"add\") [0 1] incr_idx)\n                                    (ap s $status-0_test)\n                                   )\n                                   (canon -relay- $status-0_test  #status-0_iter_canon)\n                                  )\n                                  (xor\n                                   (match #status-0_iter_canon.length incr_idx\n                                    (null)\n                                   )\n                                   (next s)\n                                  )\n                                 )\n                                 (never)\n                                )\n                                (canon -relay- $status-0_test  #status-0_result_canon)\n                               )\n                              )\n                             )\n                             (xor\n                              (match #status-0_result_canon.$.[0]! \"ok\"\n                               (ap true $result-6)\n                              )\n                              (ap false $result-6)\n                             )\n                            )\n                            (canon -relay- $result-6  #result-fix-2)\n                           )\n                          )\n                         )\n                        )\n                        (ap #result-fix-2.$.[0]! $success)\n                       )\n                      )\n                     )\n                    )\n                   )\n                  )\n                 )\n                 (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 12])\n                )\n               )\n               (new $success_test\n                (seq\n                 (fold $success s\n                  (seq\n                   (seq\n                    (seq\n                     (call %init_peer_id% (\"math\" \"add\") [0 1] incr_idx)\n                     (ap s $success_test)\n                    )\n                    (canon %init_peer_id% $success_test  #success_iter_canon)\n                   )\n                   (xor\n                    (match #success_iter_canon.length incr_idx\n                     (null)\n                    )\n                    (next s)\n                   )\n                  )\n                  (never)\n                 )\n                 (canon %init_peer_id% $success_test  #success_result_canon)\n                )\n               )\n              )\n              (xor\n               (match #success_result_canon.$.[0]! false\n                (ap \"service hasn't registered: timeout exceeded\" $error)\n               )\n               (call %init_peer_id% (\"op\" \"noop\") [])\n              )\n             )\n            )\n            (canon %init_peer_id% $success  #success-fix)\n           )\n          )\n         )\n        )\n       )\n       (canon %init_peer_id% $error  #push-to-stream-18)\n      )\n      (ap #push-to-stream-18 $-some-unique-res-name-1)\n     )\n     (par\n      (ap #success_result_canon.$.[0]! success_result_canon_flatten)\n      (canon %init_peer_id% $-some-unique-res-name-1  #-some-unique-res-name-1_canon)\n     )\n    )\n    (call %init_peer_id% (\"--after-callback-srv-service--\" \"console-log\") [success_result_canon_flatten #-some-unique-res-name-1_canon])\n   )\n   (call %init_peer_id% (\"--finisher--\" \"--finish-execution--\") [])\n  )\n  (xor\n   (call %init_peer_id% (\"callbackSrv\" \"response\") [\"ok\"])\n   (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 13])\n  )\n )\n (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 14])\n)\n";
    let script = "(xor\n (seq\n  (seq\n   (seq\n    (seq\n     (call %init_peer_id% (\"getDataSrv\" \"-relay-\") [] -relay-)\n     (new $error\n      (seq\n       (seq\n        (seq\n         (new $error-0\n          (seq\n           (new $cid\n            (seq\n             (seq\n              (seq\n               (seq\n                (seq\n                 (new $array-inline\n                  (seq\n                   (seq\n                    (seq\n                     (ap \"will upload\" $array-inline)\n                     (ap \"/Users/folex/Development/fluencelabs/subrosy/src/scheduled/scheduled.simple.air\" $array-inline)\n                    )\n                    (ap \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" $array-inline)\n                   )\n                   (canon %init_peer_id% $array-inline  #array-inline-0)\n                  )\n                 )\n                 (call %init_peer_id% (\"run-console\" \"print\") [#array-inline-0])\n                )\n                (call -relay- (\"op\" \"noop\") [])\n               )\n               (xor\n                (seq\n                 (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"aqua-ipfs\" \"get_external_api_multiaddr\") [] result)\n                 (call -relay- (\"op\" \"noop\") [])\n                )\n                (seq\n                 (call -relay- (\"op\" \"noop\") [])\n                 (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 1])\n                )\n               )\n              )\n              (xor\n               (match result.$.success! true\n                (xor\n                 (seq\n                  (seq\n                   (seq\n                    (new $array-inline-1\n                     (seq\n                      (seq\n                       (ap \"success\" $array-inline-1)\n                       (ap result.$.multiaddr! $array-inline-1)\n                      )\n                      (canon %init_peer_id% $array-inline-1  #array-inline-1-0)\n                     )\n                    )\n                    (call %init_peer_id% (\"run-console\" \"print\") [#array-inline-1-0])\n                   )\n                   (xor\n                    (call %init_peer_id% (\"ipfs_client\" \"upload\") [result.$.multiaddr! \"/Users/folex/Development/fluencelabs/subrosy/src/scheduled/scheduled.simple.air\"] cid-0)\n                    (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 2])\n                   )\n                  )\n                  (ap cid-0 $cid)\n                 )\n                 (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 3])\n                )\n               )\n               (seq\n                (seq\n                 (new $array-inline-2\n                  (seq\n                   (seq\n                    (ap \"fail\" $array-inline-2)\n                    (ap result.$.error! $array-inline-2)\n                   )\n                   (canon %init_peer_id% $array-inline-2  #array-inline-2-0)\n                  )\n                 )\n                 (call %init_peer_id% (\"run-console\" \"print\") [#array-inline-2-0])\n                )\n                (ap result.$.error! $error-0)\n               )\n              )\n             )\n             (canon %init_peer_id% $cid  #cid-fix)\n            )\n           )\n           (canon %init_peer_id% $error-0  #error-fix-0)\n          )\n         )\n         (call %init_peer_id% (\"run-console\" \"print\") [#cid-fix])\n        )\n        (xor\n         (mismatch #cid-fix []\n          (xor\n           (seq\n            (new $error_reg\n             (new $error-1\n              (seq\n               (new $error_cre\n                (seq\n                 (seq\n                  (seq\n                   (new $resource_id\n                    (seq\n                     (new $successful\n                      (seq\n                       (call %init_peer_id% (\"peer\" \"timestamp_sec\") [] t)\n                       (xor\n                        (seq\n                         (seq\n                          (call -relay- (\"registry\" \"get_key_bytes\") [\"folex\" [] t [] \"\"] bytes)\n                          (xor\n                           (call %init_peer_id% (\"sig\" \"sign\") [bytes] result-0)\n                           (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 4])\n                          )\n                         )\n                         (xor\n                          (match result-0.$.success! false\n                           (ap result-0.$.error.[0]! $error-2)\n                          )\n                          (seq\n                           (seq\n                            (seq\n                             (seq\n                              (seq\n                               (call -relay- (\"registry\" \"get_key_id\") [\"folex\" %init_peer_id%] id)\n                               (call -relay- (\"op\" \"string_to_b58\") [id] k)\n                              )\n                              (call -relay- (\"kad\" \"neighborhood\") [k [] []] nodes)\n                             )\n                             (par\n                              (fold nodes n-0\n                               (par\n                                (seq\n                                 (xor\n                                  (xor\n                                   (seq\n                                    (seq\n                                     (seq\n                                      (call n-0 (\"peer\" \"timestamp_sec\") [] t-0)\n                                      (call n-0 (\"trust-graph\" \"get_weight\") [%init_peer_id% t-0] weight)\n                                     )\n                                     (call n-0 (\"registry\" \"register_key\") [\"folex\" [] t [] \"\" result-0.$.signature.[0]! weight t-0] result-1)\n                                    )\n                                    (xor\n                                     (match result-1.$.success! true\n                                      (ap true $successful)\n                                     )\n                                     (ap result-1.$.error! $error-2)\n                                    )\n                                   )\n                                   (call n-0 (\"op\" \"noop\") [])\n                                  )\n                                  (seq\n                                   (call -relay- (\"op\" \"noop\") [])\n                                   (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 5])\n                                  )\n                                 )\n                                 (call -relay- (\"op\" \"noop\") [])\n                                )\n                                (next n-0)\n                               )\n                               (never)\n                              )\n                              (null)\n                             )\n                            )\n                            (new $status\n                             (new $result-2\n                              (seq\n                               (seq\n                                (seq\n                                 (par\n                                  (seq\n                                   (seq\n                                    (call -relay- (\"math\" \"sub\") [1 1] sub)\n                                    (new $successful_test\n                                     (seq\n                                      (fold $successful s\n                                       (seq\n                                        (seq\n                                         (seq\n                                          (call -relay- (\"math\" \"add\") [sub 1] incr_idx)\n                                          (ap s $successful_test)\n                                         )\n                                         (canon -relay- $successful_test  #successful_iter_canon)\n                                        )\n                                        (xor\n                                         (match #successful_iter_canon.length incr_idx\n                                          (null)\n                                         )\n                                         (next s)\n                                        )\n                                       )\n                                       (never)\n                                      )\n                                      (canon -relay- $successful_test  #successful_result_canon)\n                                     )\n                                    )\n                                   )\n                                   (ap \"ok\" $status)\n                                  )\n                                  (call -relay- (\"peer\" \"timeout\") [6000 \"timeout\"] $status)\n                                 )\n                                 (new $status_test\n                                  (seq\n                                   (fold $status s\n                                    (seq\n                                     (seq\n                                      (seq\n                                       (call -relay- (\"math\" \"add\") [0 1] incr_idx)\n                                       (ap s $status_test)\n                                      )\n                                      (canon -relay- $status_test  #status_iter_canon)\n                                     )\n                                     (xor\n                                      (match #status_iter_canon.length incr_idx\n                                       (null)\n                                      )\n                                      (next s)\n                                     )\n                                    )\n                                    (never)\n                                   )\n                                   (canon -relay- $status_test  #status_result_canon)\n                                  )\n                                 )\n                                )\n                                (xor\n                                 (match #status_result_canon.$.[0]! \"ok\"\n                                  (ap true $result-2)\n                                 )\n                                 (ap false $result-2)\n                                )\n                               )\n                               (canon -relay- $result-2  #result-fix)\n                              )\n                             )\n                            )\n                           )\n                           (xor\n                            (match #result-fix.$.[0]! false\n                             (ap \"resource wasn't created: timeout exceeded\" $error-2)\n                            )\n                            (ap id $resource_id)\n                           )\n                          )\n                         )\n                        )\n                        (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 6])\n                       )\n                      )\n                     )\n                     (canon %init_peer_id% $resource_id  #resource_id-fix)\n                    )\n                   )\n                   (canon %init_peer_id% $error-2  #push-to-stream-82)\n                  )\n                  (ap #push-to-stream-82 $error_cre)\n                 )\n                 (xor\n                  (mismatch #resource_id-fix []\n                   (xor\n                    (seq\n                     (seq\n                      (seq\n                       (seq\n                        (new $option-inline\n                         (seq\n                          (xor\n                           (ap #cid-fix.$.[0]! $option-inline)\n                           (null)\n                          )\n                          (canon %init_peer_id% $option-inline  #option-inline-0)\n                         )\n                        )\n                        (new $successful-0\n                         (new $error_get\n                          (new $success-0\n                           (seq\n                            (new $relay_id\n                             (seq\n                              (seq\n                               (seq\n                                (xor\n                                 (match \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" %init_peer_id%\n                                  (ap -relay- $relay_id)\n                                 )\n                                 (call %init_peer_id% (\"op\" \"noop\") [])\n                                )\n                                (xor\n                                 (seq\n                                  (new $error-4\n                                   (seq\n                                    (new $result-3\n                                     (seq\n                                      (seq\n                                       (seq\n                                        (seq\n                                         (seq\n                                          (call -relay- (\"peer\" \"timestamp_sec\") [] t-2)\n                                          (par\n                                           (ap #resource_id-fix.$.[0]! resource_id-fix_flatten)\n                                           (canon -relay- $relay_id  #relay_id_canon)\n                                          )\n                                         )\n                                         (call -relay- (\"registry\" \"get_record_metadata_bytes\") [resource_id-fix_flatten %init_peer_id% t-2 \"role=ipfs_healthcheck_script\" \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" #relay_id_canon #option-inline-0 []] bytes-0)\n                                        )\n                                        (xor\n                                         (call %init_peer_id% (\"sig\" \"sign\") [bytes-0] sig_result-0)\n                                         (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 7])\n                                        )\n                                       )\n                                       (xor\n                                        (match sig_result-0.$.success! true\n                                         (xor\n                                          (seq\n                                           (par\n                                            (ap #resource_id-fix.$.[0]! resource_id-fix_flatten-0)\n                                            (canon -relay- $relay_id  #relay_id_canon-0)\n                                           )\n                                           (call -relay- (\"registry\" \"create_record_metadata\") [resource_id-fix_flatten-0 %init_peer_id% t-2 \"role=ipfs_healthcheck_script\" \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" #relay_id_canon-0 #option-inline-0 [] sig_result-0.$.signature.[0]!] $result-3)\n                                          )\n                                          (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 8])\n                                         )\n                                        )\n                                        (ap sig_result-0.$.error.[0]! $error-4)\n                                       )\n                                      )\n                                      (canon -relay- $result-3  #result-fix-0)\n                                     )\n                                    )\n                                    (canon -relay- $error-4  #error-fix-2)\n                                   )\n                                  )\n                                  (xor\n                                   (match #result-fix-0 []\n                                    (seq\n                                     (ap false $success-0)\n                                     (ap #error-fix-2.$.[0]! $error-3)\n                                    )\n                                   )\n                                   (seq\n                                    (seq\n                                     (call -relay- (\"peer\" \"timestamp_sec\") [] t-1)\n                                     (new $signature\n                                      (seq\n                                       (xor\n                                        (mismatch #result-fix-0.$.[0].peer_id! %init_peer_id%\n                                         (xor\n                                          (xor\n                                           (seq\n                                            (seq\n                                             (ap #result-fix-0.$.[0]! result-fix-0_flatten)\n                                             (call #result-fix-0.$.[0].peer_id! (\"registry\" \"get_record_bytes\") [result-fix-0_flatten t-1] bytes-1)\n                                            )\n                                            (call #result-fix-0.$.[0].peer_id! (\"sig\" \"sign\") [bytes-1] $signature)\n                                           )\n                                           (seq\n                                            (call -relay- (\"op\" \"noop\") [])\n                                            (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 9])\n                                           )\n                                          )\n                                          (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 10])\n                                         )\n                                        )\n                                        (xor\n                                         (seq\n                                          (seq\n                                           (ap #result-fix-0.$.[0]! result-fix-0_flatten-0)\n                                           (call -relay- (\"registry\" \"get_record_bytes\") [result-fix-0_flatten-0 t-1] bytess)\n                                          )\n                                          (xor\n                                           (call %init_peer_id% (\"sig\" \"sign\") [bytess] $signature)\n                                           (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 11])\n                                          )\n                                         )\n                                         (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 12])\n                                        )\n                                       )\n                                       (canon -relay- $signature  #signature-fix)\n                                      )\n                                     )\n                                    )\n                                    (xor\n                                     (match #signature-fix.$.[0].success! false\n                                      (seq\n                                       (ap #signature-fix.$.[0].error.[0]! $error-3)\n                                       (ap false $success-0)\n                                      )\n                                     )\n                                     (seq\n                                      (seq\n                                       (seq\n                                        (new $resources\n                                         (new $successful-1\n                                          (new $result-4\n                                           (seq\n                                            (seq\n                                             (seq\n                                              (seq\n                                               (seq\n                                                (seq\n                                                 (ap #resource_id-fix.$.[0]! resource_id-fix_flatten-1)\n                                                 (call -relay- (\"op\" \"string_to_b58\") [resource_id-fix_flatten-1] k-0)\n                                                )\n                                                (call -relay- (\"kad\" \"neighborhood\") [k-0 [] []] nodes-2)\n                                               )\n                                               (par\n                                                (fold nodes-2 n-2-0\n                                                 (par\n                                                  (seq\n                                                   (xor\n                                                    (xor\n                                                     (seq\n                                                      (seq\n                                                       (ap #resource_id-fix.$.[0]! resource_id-fix_flatten-2)\n                                                       (call n-2-0 (\"registry\" \"get_key_metadata\") [resource_id-fix_flatten-2] get_result)\n                                                      )\n                                                      (xor\n                                                       (match get_result.$.success! true\n                                                        (seq\n                                                         (ap get_result.$.key! $resources)\n                                                         (ap true $successful-1)\n                                                        )\n                                                       )\n                                                       (seq\n                                                        (call n-2-0 (\"op\" \"concat_strings\") [get_result.$.error! \" on \"] e)\n                                                        (call n-2-0 (\"op\" \"concat_strings\") [e n-2-0] $error-5)\n                                                       )\n                                                      )\n                                                     )\n                                                     (call n-2-0 (\"op\" \"noop\") [])\n                                                    )\n                                                    (seq\n                                                     (call -relay- (\"op\" \"noop\") [])\n                                                     (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 13])\n                                                    )\n                                                   )\n                                                   (call -relay- (\"op\" \"noop\") [])\n                                                  )\n                                                  (next n-2-0)\n                                                 )\n                                                 (never)\n                                                )\n                                                (null)\n                                               )\n                                              )\n                                              (new $status-0\n                                               (new $result-5\n                                                (seq\n                                                 (seq\n                                                  (seq\n                                                   (par\n                                                    (seq\n                                                     (seq\n                                                      (call -relay- (\"math\" \"sub\") [1 1] sub-0)\n                                                      (new $successful-1_test\n                                                       (seq\n                                                        (fold $successful-1 s\n                                                         (seq\n                                                          (seq\n                                                           (seq\n                                                            (call -relay- (\"math\" \"add\") [sub-0 1] incr_idx)\n                                                            (ap s $successful-1_test)\n                                                           )\n                                                           (canon -relay- $successful-1_test  #successful-1_iter_canon)\n                                                          )\n                                                          (xor\n                                                           (match #successful-1_iter_canon.length incr_idx\n                                                            (null)\n                                                           )\n                                                           (next s)\n                                                          )\n                                                         )\n                                                         (never)\n                                                        )\n                                                        (canon -relay- $successful-1_test  #successful-1_result_canon)\n                                                       )\n                                                      )\n                                                     )\n                                                     (ap \"ok\" $status-0)\n                                                    )\n                                                    (call -relay- (\"peer\" \"timeout\") [6000 \"timeout\"] $status-0)\n                                                   )\n                                                   (new $status-0_test\n                                                    (seq\n                                                     (fold $status-0 s\n                                                      (seq\n                                                       (seq\n                                                        (seq\n                                                         (call -relay- (\"math\" \"add\") [0 1] incr_idx)\n                                                         (ap s $status-0_test)\n                                                        )\n                                                        (canon -relay- $status-0_test  #status-0_iter_canon)\n                                                       )\n                                                       (xor\n                                                        (match #status-0_iter_canon.length incr_idx\n                                                         (null)\n                                                        )\n                                                        (next s)\n                                                       )\n                                                      )\n                                                      (never)\n                                                     )\n                                                     (canon -relay- $status-0_test  #status-0_result_canon)\n                                                    )\n                                                   )\n                                                  )\n                                                  (xor\n                                                   (match #status-0_result_canon.$.[0]! \"ok\"\n                                                    (ap true $result-5)\n                                                   )\n                                                   (ap false $result-5)\n                                                  )\n                                                 )\n                                                 (canon -relay- $result-5  #result-fix-2)\n                                                )\n                                               )\n                                              )\n                                             )\n                                             (xor\n                                              (match #result-fix-2.$.[0]! false\n                                               (ap \"resource not found: timeout exceeded\" $error-5)\n                                              )\n                                              (seq\n                                               (seq\n                                                (canon -relay- $resources  #resources_canon)\n                                                (call -relay- (\"registry\" \"merge_keys\") [#resources_canon] merge_result)\n                                               )\n                                               (xor\n                                                (match merge_result.$.success! true\n                                                 (ap merge_result.$.key! $result-4)\n                                                )\n                                                (ap merge_result.$.error! $error-5)\n                                               )\n                                              )\n                                             )\n                                            )\n                                            (canon -relay- $result-4  #result-fix-1)\n                                           )\n                                          )\n                                         )\n                                        )\n                                        (canon -relay- $error-5  #push-to-stream-273)\n                                       )\n                                       (ap #push-to-stream-273 $error_get)\n                                      )\n                                      (xor\n                                       (match #result-fix-1 []\n                                        (xor\n                                         (seq\n                                          (seq\n                                           (canon -relay- $error_get  #error_get_canon)\n                                           (fold #error_get_canon e-0-0\n                                            (seq\n                                             (ap e-0-0 $error-3)\n                                             (next e-0-0)\n                                            )\n                                           )\n                                          )\n                                          (ap false $success-0)\n                                         )\n                                         (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 14])\n                                        )\n                                       )\n                                       (seq\n                                        (seq\n                                         (seq\n                                          (seq\n                                           (seq\n                                            (seq\n                                             (seq\n                                              (call -relay- (\"op\" \"noop\") [])\n                                              (xor\n                                               (mismatch \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" %init_peer_id%\n                                                (xor\n                                                 (xor\n                                                  (seq\n                                                   (seq\n                                                    (seq\n                                                     (seq\n                                                      (seq\n                                                       (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"peer\" \"timestamp_sec\") [] t-3)\n                                                       (ap #result-fix-1.$.[0].owner_peer_id! result-fix-1_flatten)\n                                                      )\n                                                      (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"trust-graph\" \"get_weight\") [result-fix-1_flatten t-3] weight-0)\n                                                     )\n                                                     (ap #result-fix-1.$.[0]! result-fix-1_flatten-0)\n                                                    )\n                                                    (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"registry\" \"republish_key\") [result-fix-1_flatten-0 weight-0 t-3] result-6)\n                                                   )\n                                                   (xor\n                                                    (match result-6.$.success! false\n                                                     (ap result-6.$.error! $error-3)\n                                                    )\n                                                    (seq\n                                                     (seq\n                                                      (seq\n                                                       (seq\n                                                        (seq\n                                                         (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"peer\" \"timestamp_sec\") [] t-4)\n                                                         (ap #result-fix-0.$.[0].issued_by! result-fix-0_flatten-1)\n                                                        )\n                                                        (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"trust-graph\" \"get_weight\") [result-fix-0_flatten-1 t-4] weight-1)\n                                                       )\n                                                       (par\n                                                        (ap #result-fix-0.$.[0]! result-fix-0_flatten-2)\n                                                        (ap #signature-fix.$.[0].signature.[0]! signature-fix_flatten)\n                                                       )\n                                                      )\n                                                      (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"registry\" \"put_record\") [result-fix-0_flatten-2 t-1 signature-fix_flatten weight-1 t-4] result-7)\n                                                     )\n                                                     (xor\n                                                      (match result-7.$.success! false\n                                                       (seq\n                                                        (ap result-7.$.error! $error-3)\n                                                        (ap false $success-0)\n                                                       )\n                                                      )\n                                                      (call \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" (\"op\" \"noop\") [])\n                                                     )\n                                                    )\n                                                   )\n                                                  )\n                                                  (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 15])\n                                                 )\n                                                 (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 16])\n                                                )\n                                               )\n                                               (call -relay- (\"op\" \"noop\") [])\n                                              )\n                                             )\n                                             (ap #resource_id-fix.$.[0]! resource_id-fix_flatten-3)\n                                            )\n                                            (call -relay- (\"op\" \"string_to_b58\") [resource_id-fix_flatten-3] k-1)\n                                           )\n                                           (call -relay- (\"kad\" \"neighborhood\") [k-1 [] []] nodes-3)\n                                          )\n                                          (par\n                                           (fold nodes-3 n-1-0\n                                            (par\n                                             (seq\n                                              (xor\n                                               (xor\n                                                (seq\n                                                 (seq\n                                                  (seq\n                                                   (seq\n                                                    (seq\n                                                     (call n-1-0 (\"peer\" \"timestamp_sec\") [] t-5)\n                                                     (ap #result-fix-1.$.[0].owner_peer_id! result-fix-1_flatten-1)\n                                                    )\n                                                    (call n-1-0 (\"trust-graph\" \"get_weight\") [result-fix-1_flatten-1 t-5] weight-2)\n                                                   )\n                                                   (ap #result-fix-1.$.[0]! result-fix-1_flatten-2)\n                                                  )\n                                                  (call n-1-0 (\"registry\" \"republish_key\") [result-fix-1_flatten-2 weight-2 t-5] result-8)\n                                                 )\n                                                 (xor\n                                                  (match result-8.$.success! false\n                                                   (ap result-8.$.error! $error-3)\n                                                  )\n                                                  (seq\n                                                   (seq\n                                                    (seq\n                                                     (seq\n                                                      (seq\n                                                       (call n-1-0 (\"peer\" \"timestamp_sec\") [] t-6)\n                                                       (ap #result-fix-0.$.[0].issued_by! result-fix-0_flatten-3)\n                                                      )\n                                                      (call n-1-0 (\"trust-graph\" \"get_weight\") [result-fix-0_flatten-3 t-6] weight-3)\n                                                     )\n                                                     (par\n                                                      (ap #result-fix-0.$.[0]! result-fix-0_flatten-4)\n                                                      (ap #signature-fix.$.[0].signature.[0]! signature-fix_flatten-0)\n                                                     )\n                                                    )\n                                                    (call n-1-0 (\"registry\" \"put_record\") [result-fix-0_flatten-4 t-1 signature-fix_flatten-0 weight-3 t-6] result-9)\n                                                   )\n                                                   (xor\n                                                    (match result-9.$.success! true\n                                                     (ap true $successful-0)\n                                                    )\n                                                    (ap result-9.$.error! $error-3)\n                                                   )\n                                                  )\n                                                 )\n                                                )\n                                                (call n-1-0 (\"op\" \"noop\") [])\n                                               )\n                                               (seq\n                                                (call -relay- (\"op\" \"noop\") [])\n                                                (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 17])\n                                               )\n                                              )\n                                              (call -relay- (\"op\" \"noop\") [])\n                                             )\n                                             (next n-1-0)\n                                            )\n                                            (never)\n                                           )\n                                           (null)\n                                          )\n                                         )\n                                         (new $status-1\n                                          (new $result-10\n                                           (seq\n                                            (seq\n                                             (seq\n                                              (par\n                                               (seq\n                                                (seq\n                                                 (call -relay- (\"math\" \"sub\") [1 1] sub-1)\n                                                 (new $successful-0_test\n                                                  (seq\n                                                   (fold $successful-0 s\n                                                    (seq\n                                                     (seq\n                                                      (seq\n                                                       (call -relay- (\"math\" \"add\") [sub-1 1] incr_idx)\n                                                       (ap s $successful-0_test)\n                                                      )\n                                                      (canon -relay- $successful-0_test  #successful-0_iter_canon)\n                                                     )\n                                                     (xor\n                                                      (match #successful-0_iter_canon.length incr_idx\n                                                       (null)\n                                                      )\n                                                      (next s)\n                                                     )\n                                                    )\n                                                    (never)\n                                                   )\n                                                   (canon -relay- $successful-0_test  #successful-0_result_canon)\n                                                  )\n                                                 )\n                                                )\n                                                (ap \"ok\" $status-1)\n                                               )\n                                               (call -relay- (\"peer\" \"timeout\") [6000 \"timeout\"] $status-1)\n                                              )\n                                              (new $status-1_test\n                                               (seq\n                                                (fold $status-1 s\n                                                 (seq\n                                                  (seq\n                                                   (seq\n                                                    (call -relay- (\"math\" \"add\") [0 1] incr_idx)\n                                                    (ap s $status-1_test)\n                                                   )\n                                                   (canon -relay- $status-1_test  #status-1_iter_canon)\n                                                  )\n                                                  (xor\n                                                   (match #status-1_iter_canon.length incr_idx\n                                                    (null)\n                                                   )\n                                                   (next s)\n                                                  )\n                                                 )\n                                                 (never)\n                                                )\n                                                (canon -relay- $status-1_test  #status-1_result_canon)\n                                               )\n                                              )\n                                             )\n                                             (xor\n                                              (match #status-1_result_canon.$.[0]! \"ok\"\n                                               (ap true $result-10)\n                                              )\n                                              (ap false $result-10)\n                                             )\n                                            )\n                                            (canon -relay- $result-10  #result-fix-3)\n                                           )\n                                          )\n                                         )\n                                        )\n                                        (ap #result-fix-3.$.[0]! $success-0)\n                                       )\n                                      )\n                                     )\n                                    )\n                                   )\n                                  )\n                                 )\n                                 (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 18])\n                                )\n                               )\n                               (new $success-0_test\n                                (seq\n                                 (fold $success-0 s\n                                  (seq\n                                   (seq\n                                    (seq\n                                     (call %init_peer_id% (\"math\" \"add\") [0 1] incr_idx)\n                                     (ap s $success-0_test)\n                                    )\n                                    (canon %init_peer_id% $success-0_test  #success-0_iter_canon)\n                                   )\n                                   (xor\n                                    (match #success-0_iter_canon.length incr_idx\n                                     (null)\n                                    )\n                                    (next s)\n                                   )\n                                  )\n                                  (never)\n                                 )\n                                 (canon %init_peer_id% $success-0_test  #success-0_result_canon)\n                                )\n                               )\n                              )\n                              (xor\n                               (match #success-0_result_canon.$.[0]! false\n                                (ap \"service hasn't registered: timeout exceeded\" $error-3)\n                               )\n                               (call %init_peer_id% (\"op\" \"noop\") [])\n                              )\n                             )\n                            )\n                            (canon %init_peer_id% $success-0  #success-fix)\n                           )\n                          )\n                         )\n                        )\n                       )\n                       (canon %init_peer_id% $error-3  #push-to-stream-181)\n                      )\n                      (ap #push-to-stream-181 $error_reg)\n                     )\n                     (xor\n                      (match #success-0_result_canon.$.[0]! false\n                       (seq\n                        (canon %init_peer_id% $error_reg  #push-to-stream-497)\n                        (ap #push-to-stream-497 $error-1)\n                       )\n                      )\n                      (call %init_peer_id% (\"op\" \"noop\") [])\n                     )\n                    )\n                    (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 19])\n                   )\n                  )\n                  (seq\n                   (canon %init_peer_id% $error_cre  #push-to-stream-167)\n                   (ap #push-to-stream-167 $error-1)\n                  )\n                 )\n                )\n               )\n               (canon %init_peer_id% $error-1  #error-fix-1)\n              )\n             )\n            )\n            (xor\n             (mismatch #error-fix-1 []\n              (ap #error-fix-1.$.[0]! $error)\n             )\n             (call %init_peer_id% (\"op\" \"noop\") [])\n            )\n           )\n           (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 20])\n          )\n         )\n         (seq\n          (new $array-inline-3\n           (seq\n            (seq\n             (seq\n              (seq\n               (ap \"upload_air\" $array-inline-3)\n               (ap \"12D3KooWHCJbJKGDfCgHSoCuK9q4STyRnVveqLoXAPBbXHTZx9Cv\" $array-inline-3)\n              )\n              (ap \"/Users/folex/Development/fluencelabs/subrosy/src/scheduled/scheduled.simple.air\" $array-inline-3)\n             )\n             (ap #error-fix-0.$.[0]! $array-inline-3)\n            )\n            (canon %init_peer_id% $array-inline-3  #array-inline-3-0)\n           )\n          )\n          (ap #array-inline-3-0 $error)\n         )\n        )\n       )\n       (canon %init_peer_id% $error  #error-fix)\n      )\n     )\n    )\n    (call %init_peer_id% (\"--after-callback-srv-service--\" \"console-log\") [#error-fix])\n   )\n   (call %init_peer_id% (\"--finisher--\" \"--finish-execution--\") [])\n  )\n  (xor\n   (call %init_peer_id% (\"callbackSrv\" \"response\") [\"ok\"])\n   (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 21])\n  )\n )\n (call %init_peer_id% (\"errorHandlingSrv\" \"error\") [%last_error% 22])\n)\n";

    let prev_data: InterpreterData = serde_json::from_str(PREV_DATA).unwrap();
    let prev_data = serde_json::to_vec(&prev_data).unwrap();

    let current_data: InterpreterData = serde_json::from_str(CURRENT_DATA).unwrap();
    let trace = current_data.trace.clone();
    let current_data = serde_json::to_vec(&current_data).unwrap();

    println!("trace current_data (states_count: {}): [", trace.len());
    for (id, state) in trace.iter().enumerate() {
        println!("  {}: {}", id, state);
    }
    println!("]");

    let test_run_paremeters = TestRunParameters::new(
        "12D3KooWJdk3sMRAHdy3Tuu5121EkG8LrhHdzDCKZh1ZyitnBXsN",
        1665582317176,
        100000,
    );
    let result = checked_call_vm!(vm, test_run_paremeters, script, prev_data, current_data);
    println!("next_peer_pks: {:?}", result.next_peer_pks);
}
